"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("util");
'use strict';
const fs = require("fs");
const neatCsv = require('neat-csv');
const lbl = require('line-by-line');
class CsvFileReader {
    convert(filePath, maxcount = 0) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise(function (resolve, reject) {
                const lines = [];
                const reader = new lbl(filePath);
                reader.on('error', function (err) {
                    reject(err);
                });
                reader.on('line', function (line) {
                    if (maxcount <= 0 || lines.length < (maxcount + 1)) {
                        lines.push(line);
                    }
                    if (maxcount > 0 && lines.length === (maxcount + 1)) {
                        reader.pause();
                        reader.emit('end');
                        return;
                    }
                });
                reader.on('end', function () {
                    return __awaiter(this, void 0, void 0, function* () {
                        const csv = lines.join('\n');
                        try {
                            const out = yield neatCsv(csv, { strict: true });
                            resolve(out);
                        }
                        catch (err) {
                            reject(err);
                        }
                    });
                });
            });
        });
    }
}
exports.CsvFileReader = CsvFileReader;
class JsonFileReader {
    convert(filePath, maxcount) {
        return __awaiter(this, void 0, void 0, function* () {
            const obj = JSON.parse(fs.readFileSync(filePath, 'utf-8'));
            if (util_1.isArray(obj)) {
                return obj;
            }
            return [obj];
        });
    }
}
exports.JsonFileReader = JsonFileReader;
//# sourceMappingURL=FileReaders.js.map