/// <reference types="node" />
import { URL } from 'url';
export declare class LyticsAccount {
    aid: number;
    apikey: string | undefined;
    created: string | undefined;
    dataapikey: string | undefined;
    domain: string | undefined;
    email: string | undefined;
    features: {
        "audience-attribution": boolean;
        campaigns: boolean;
        "content-classification": boolean;
    };
    fid: string | undefined;
    id: string | undefined;
    locked: boolean;
    masteraid: number;
    name: string | undefined;
    package_id: string | undefined;
    parent_id: string | undefined;
    parentaid: number;
    partner_id: string | undefined;
    partner_slug: string | undefined;
    provider_id: string | undefined;
    pubusers: boolean;
    two_factor_auth: boolean;
    updated: string | undefined;
    whitelist_fields: string[];
    constructor();
}
export declare class GetAccountsResponse {
    data: LyticsAccount[];
    message: string | undefined;
    status: number;
}
export declare class GetAccountResponse {
    data: LyticsAccount | undefined;
    message: string | undefined;
    status: number;
}
export declare class DataStreamFieldColumn {
    as: string | undefined;
    table: string | undefined;
}
export declare class DataStreamFieldSmartFields {
    analyses: number;
    coverage: number;
    email: number;
    ip: number;
    noun: number;
    phone: number;
    time: number;
    uid: number;
    url: number;
    value: number;
    verb: number;
}
export declare class DataStreamField {
    avg: number;
    card: number;
    column: DataStreamFieldColumn[];
    first_seen: string | undefined;
    hidden: boolean;
    is_array: boolean;
    last_seen: string | undefined;
    name: string | undefined;
    sample: string[];
    smart: DataStreamFieldSmartFields | undefined;
    sumlen: number;
    type: string | undefined;
    usage: number;
}
export declare class DataStream {
    avg_event_size: number;
    ct: number;
    curct: number;
    fields: DataStreamField[];
    hidden: boolean;
    last_msg_ts: string | undefined;
    last_update_ts: string | undefined;
    recent_events: any[];
    stream: string | undefined;
}
export declare class TableSchemaField {
    as: string | undefined;
    froms: string[];
    hidden: boolean;
    identities: string[];
    is_by: boolean;
    longdesc: string | undefined;
    private: boolean;
    shortdesc: string | undefined;
    type: string | undefined;
}
export declare class TableSchema {
    by_fields: string[];
    columns: TableSchemaField[];
    name: string | undefined;
}
export declare class TableSchemaFieldInfo {
    approx_cardinality: number;
    ents_absent: number;
    ents_present: number;
    field: string | undefined;
    more_terms: boolean;
    terms_counts: any;
    static getTermCounts: (obj: any) => TableSchemaFieldInfoTermCount[];
}
export declare class TableSchemaFieldInfoTermCount {
    value: string | undefined;
    count: number;
}
export declare class QueryValidationResult {
    success: boolean;
    message: string | undefined;
    query: Query | undefined;
}
export declare class Query {
    alias: string | undefined;
    by_fields: string[];
    created: string | undefined;
    description: string | undefined;
    disabled: boolean;
    fields: QueryField[];
    from: string | undefined;
    id: string | undefined;
    into: string | undefined;
    keyword: string | undefined;
    query_type: string | undefined;
    table: string | undefined;
    text: string | undefined;
    updated: string | undefined;
}
export declare class QueryField {
    as: string | undefined;
    froms: string[];
    hidden: boolean;
    identities: string[];
    is_by: boolean;
    longdesc: string | undefined;
    private: boolean;
    shortdesc: string | undefined;
    type: string | undefined;
}
export declare class CollectResultInfo {
    message_count: number;
    rejected_count: number;
    "content-type": string | undefined;
    droperrors: boolean;
    dryrun: boolean;
    timestamp_field: string | undefined;
    filename: string | undefined;
}
export declare class SegmentGrouping {
    audiences: Segment[];
    characteristics: Segment[];
    unidentified: Segment[];
}
export declare class Segment {
    account_id: string | undefined;
    aid: number;
    ast: any;
    author_id: string | undefined;
    created: string | undefined;
    datemath_calc: boolean;
    deleted: boolean;
    description: string | undefined;
    forward_datemath: boolean;
    id: string | undefined;
    invalid: boolean;
    invalid_reason: string | undefined;
    is_public: boolean;
    kind: string | undefined;
    name: string | undefined;
    public_name: string | undefined;
    save_hist: boolean;
    schedule_exit: boolean;
    segment_ql: string | undefined;
    short_id: string | undefined;
    slug_name: string | undefined;
    table: string | undefined;
    tags: string[];
    updated: string | undefined;
}
export declare class SegmentCollectionMember {
    id: string | undefined;
    order: number;
}
export declare class SegmentCollection {
    aid: number;
    account_id: string | undefined;
    id: string | undefined;
    name: string | undefined;
    slug_name: string | undefined;
    kind: string | undefined;
    table: string | undefined;
    author_id: string | undefined;
    updated: Date | undefined;
    created: Date | undefined;
    internal: boolean;
    collection: SegmentCollectionMember[];
    parent_segment: string | undefined;
}
export declare class Campaign {
    id: string | undefined;
    aid: number;
    account_id: string | undefined;
    user_id: string | undefined;
    created: string | undefined;
    updated: string | undefined;
    created_at: string | undefined;
    updated_at: string | undefined;
    name: string | undefined;
    system_status: string | undefined;
    published_at: string | undefined;
    start_at: string | undefined;
    segments: string[];
}
export declare class CampaignVariation {
    id: string | undefined;
    aid: number;
    account_id: string | undefined;
    user_id: string | undefined;
    created: string | undefined;
    updated: string | undefined;
    created_at: string | undefined;
    updated_at: string | undefined;
    variation: number;
    campaign_id: string | undefined;
    vehicle: string | undefined;
    reach: string | undefined;
    conversion: string | undefined;
    detail: CampaignVariationDetail | undefined;
    detail_override: CampaignVariationDetailOverride | undefined;
}
export declare class CampaignVariationDetail {
    appearsOn: CampaignVariationAppearanceRule[];
    attachment: string | undefined;
    body: string | undefined;
    className: string | undefined;
    colors: CampaignVariationColor[];
    displayOptions: CampaignVariationDisplayOption[];
    formFields: CampaignVariationFormField[];
    headline: string | undefined;
    image: string | undefined;
    layout: string | undefined;
    okMessage: string | undefined;
    theme: string | undefined;
    typeKey: string | undefined;
}
export declare class CampaignVariationAppearanceRule {
    exclude: boolean;
    match: string | undefined;
    value: string | undefined;
}
export declare class CampaignVariationColor {
    hex: string | undefined;
    key: string | undefined;
    title: string | undefined;
}
export declare class CampaignVariationDisplayOption {
    key: string | undefined;
    value: string | undefined;
}
export declare class CampaignVariationFormField {
    isEnabled: boolean;
    isRequired: boolean;
    placeholder: string | undefined;
    slug: string | undefined;
}
export declare class CampaignVariationDetailOverride {
    confirmAction: CampaignVariationDetailOverrideConfirmAction | undefined;
    fields: CampaignVariationDetailOverrideFields | undefined;
    formElements: CampaignVariationDetailOverrideFormElement[];
    formFields: any[];
    formStates: CampaignVariationDetailOverrideFormStates | undefined;
}
export declare class CampaignVariationDetailOverrideConfirmAction {
    callback: string | undefined;
    waitForAsyncResponse: boolean;
}
export declare class CampaignVariationDetailOverrideFields {
    name: boolean;
    email: boolean;
    title: boolean;
    company: boolean;
    phone: boolean;
    referralEmail: boolean;
    message: boolean;
}
export declare class CampaignVariationDetailOverrideFormElement {
    label: string | undefined;
    name: string | undefined;
    required: boolean;
    type: string | undefined;
}
export declare class CampaignVariationDetailOverrideFormStates {
    error: CampaignVariationDetailOverrideFormState | undefined;
    success: CampaignVariationDetailOverrideFormState | undefined;
}
export declare class CampaignVariationDetailOverrideFormState {
    delay: number;
    headline: string | undefined;
    msg: string | undefined;
}
export declare class ContentClassification {
    id: string | undefined;
    fb: string | undefined;
    url: ContentClassificationUrl | undefined;
    canonical: string | undefined;
    url_redirected_from: string | undefined;
    description: string | undefined;
    long_description: string | undefined;
    type: string | undefined;
    source: string | undefined;
    stream: string | undefined;
    httpstatus: number;
    httpfailures: number;
    humanLanguage: string | undefined;
    tags: ContentClassificationTag[];
    images: ContentClassificationImage[];
    primary_image: string | undefined;
    videos: ContentClassificationVideo[];
    primary_video: string | undefined;
    published: string | undefined;
    author: string | undefined;
    numpages: number;
    sitename: string | undefined;
    productDescription: string | undefined;
    brand: string | undefined;
    price: string | undefined;
    saveAmount: string | undefined;
    productId: string | undefined;
    created: Date | undefined;
    fetched: Date | undefined;
    updated: Date | undefined;
    enriched: any;
    version: number;
}
export declare class ContentClassificationUrl {
    Params: any;
    Parsed: any;
    Utm: any;
    UserInfo: any;
    Https: boolean;
    IsStatic: boolean;
}
export declare class ContentClassificationTag {
    type: string | undefined;
    id: string | undefined;
    value: string | undefined;
    source: string | undefined;
    vocab: string | undefined;
    relevance: number;
}
export declare class ContentClassificationImage {
    url: string | undefined;
}
export declare class ContentClassificationVideo {
    url: string | undefined;
}
export declare class Topic {
    label: string | undefined;
    doc_count: number;
    total: number;
    missing: number;
    present: number;
    bucket_none: number;
    bucket_low: number;
    bucket_mid: number;
    bucket_high: number;
    avg: number;
    tags: string[];
}
export declare class TopicUrl {
    url: string | undefined;
    https: boolean;
    title: string | undefined;
    description: string | undefined;
    topics: string[];
    topic_relevances: any;
    primary_image: string | undefined;
    author: string | undefined;
    created: Date | undefined;
    id: string | undefined;
    sitename: string | undefined;
    stream: string | undefined;
    aspects: string[];
    language: string | undefined;
    updated: Date | undefined;
    fetched: Date | undefined;
    meta: string[];
}
export declare class TopicUrlCollection {
    total: number;
    urls: TopicUrl[];
}
export declare class Subscription {
    aid: number;
    id: string | undefined;
    account_id: string | undefined;
    name: string | undefined;
    slug: string | undefined;
    description: string | undefined;
    channel: string | undefined;
    updated: Date | undefined;
    created: Date | undefined;
    version: string | undefined;
    table: string | undefined;
    withbackfill: boolean;
    work_id: string | undefined;
    object: string | undefined;
    segment_ids: string[];
    query: string | undefined;
    config: SubscriptionConfig | undefined;
}
export declare class SubscriptionConfig {
    channel: string | undefined;
    description: string | undefined;
    headers: any | undefined;
    name: string | undefined;
    segment_ids: string[];
    subscription_id: string | undefined;
    user_fields: string[];
    webhook_url: URL | undefined;
    version: string | undefined;
}
export declare class WebhookConfig {
    channel: string;
    version: string;
    name: string | undefined;
    description: string | undefined;
    webhook_url: URL | undefined;
    headers: any | undefined;
    segment_ids: string[];
    user_fields: string[];
    static isValid: (obj: any) => boolean;
}
export declare class TokenScope {
    readonly scope: string;
    readonly description: string;
    constructor(scope: string, description: string);
    static readonly supportedScopes: TokenScope[];
}
export declare class CreateAccessTokenConfig {
    expires: string | undefined;
    scopes: string[];
    name: string | undefined;
}
export declare class LyticsAccessToken {
    id: string | undefined;
    aid: number;
    name: string | undefined;
    account_id: string | undefined;
    provider_id: string | undefined;
    provider_name: string | undefined;
    provider_slug: string | undefined;
    auth_type: string | undefined;
    description: string | undefined;
    config: LyticsAccessTokenConfig[];
    scopes: string[];
    ttl: string | undefined;
    created: Date | undefined;
    updated: Date | undefined;
    expires: Date | undefined;
}
export declare class LyticsAccessTokenReader {
    static getApiKey: (token: LyticsAccessToken) => string | undefined;
}
export declare class LyticsAccessTokenConfig {
    name: string | undefined;
    value: string | undefined;
}
export declare class LyticsAccountSetting {
    slug: string | undefined;
    category: string | undefined;
    value: any;
    field: LyticsAccountSettingField | undefined;
    can_be_assigned: boolean;
    subject: string | undefined;
}
export declare class LyticsAccountSettingField {
    type: string | undefined;
    label: string | undefined;
    name: string | undefined;
    sort_order: number;
    optional: boolean;
    editable: boolean;
    user_config_disabled: boolean;
    description: string | undefined;
}
export declare class DocumentTopicsResult {
    total: number;
    urls: DocumentTopics[];
}
export declare class DocumentTopics {
    url: string | undefined;
    https: boolean;
    title: string | undefined;
    description: string | undefined;
    topics: string[];
    topic_relevances: any | undefined;
    primary_image: string | undefined;
    author: string | undefined;
    created: Date | undefined;
    id: string | undefined;
    sitename: string | undefined;
    stream: string | undefined;
    aspects: string[];
    language: string | undefined;
    updated: Date | undefined;
    fetched: Date | undefined;
    meta: string[];
}
export declare class DataUploadConfig {
    readonly stream: string;
    constructor(stream: string);
    timestamp_field: string | undefined;
    dryrun: boolean;
}
export declare class DataUploadResponse {
    message_count: number;
    rejected_count: number;
}
export declare class FragmentKey {
    key: string | undefined;
    value: string | undefined;
}
export declare class FragmentMetadata {
    streams: string[];
    conflict: boolean;
}
export declare class FragmentHashManager {
    static readonly _crypto: any;
    static hashValue(value: any): string;
    static getHashForKey(key: FragmentKey | FragmentKey[]): string;
}
export declare class Fragment {
    key: FragmentKey[];
    neighbors: FragmentKey[];
    fragment: any;
    meta: FragmentMetadata | undefined;
}
export declare class FragmentCollection {
    entity: any;
    keys: FragmentKey[];
    fragments: Fragment[];
}
export declare class DOT {
    static fragmentsToDot(fragments: Fragment[]): string | undefined;
}
export declare class SegmentMLModel {
    static getModelGeneration(name: string): number;
    static getModelNameWithoutGeneration(name: string): string;
    name: string | undefined;
    state: string | undefined;
    reason: string | undefined;
    created: Date | undefined;
    conf: SegmentMLModelConfig | undefined;
    features: SegmentMLModelFeature[];
    summary: SegmentMLSummary | undefined;
}
export declare class SegmentMLSummary {
    conf: SegmentMLSummaryConflicts | undefined;
    mse: number;
    rsq: number;
    success: any;
    fail: any;
    auc: number;
    threshold: number;
}
export declare class SegmentMLSummaryConflicts {
    FalsePositive: number;
    TruePositive: number;
    FalseNegative: number;
    TrueNegative: number;
}
export declare class SegmentMLModelFeature {
    kind: string | undefined;
    type: string | undefined;
    name: string | undefined;
    importance: number;
    correlation: number;
}
export declare class SegmentMLModelConfig {
    source: SegmentMLModelSegment | undefined;
    target: SegmentMLModelSegment | undefined;
}
export declare class SegmentMLModelSegment {
    aid: number;
    account_id: string | undefined;
    id: string | undefined;
    short_id: string | undefined;
    name: string | undefined;
    kind: string | undefined;
    is_public: string | undefined;
    public_name: string | undefined;
    slug_name: string | undefined;
    description: string | undefined;
    table: string | undefined;
    author_id: string | undefined;
    updated: Date | undefined;
    created: Date | undefined;
    invalid: boolean;
    invalid_reason: string | undefined;
    deleted: boolean;
    datemath_calc: boolean;
    forward_datemath: boolean;
    save_hist: boolean;
    schedule_exit: boolean;
    segment_ql: string | undefined;
    tags: string[];
    ast: any;
}
export declare class CreateSegmentMLModelConfig {
    source: string | undefined;
    target: string | undefined;
    use_scores: boolean;
    target_field: string | undefined;
    use_content: boolean;
    aspect_collections: string[];
    additional_fields: string[];
    model_only: boolean;
    eval_only: boolean;
    tune_model: boolean;
    write_to_gcs: boolean;
    tags: string[];
    re_run: boolean;
    save_segments: boolean;
    as_is: boolean;
    num_to_train: number | undefined;
    cor_threshold: number | undefined;
}
