"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("util");
class LyticsAccount {
    constructor() {
        this.aid = 0;
        this.locked = false;
        this.masteraid = 0;
        this.parentaid = 0;
        this.pubusers = false;
        this.two_factor_auth = false;
        this.whitelist_fields = [];
        this.features = {
            "audience-attribution": false,
            "content-classification": false,
            campaigns: false
        };
    }
}
exports.LyticsAccount = LyticsAccount;
class GetAccountsResponse {
    constructor() {
        this.data = [];
        this.status = 0;
    }
}
exports.GetAccountsResponse = GetAccountsResponse;
class GetAccountResponse {
    constructor() {
        this.status = 0;
    }
}
exports.GetAccountResponse = GetAccountResponse;
class DataStreamFieldColumn {
}
exports.DataStreamFieldColumn = DataStreamFieldColumn;
class DataStreamFieldSmartFields {
    constructor() {
        this.analyses = 0;
        this.coverage = 0;
        this.email = 0;
        this.ip = 0;
        this.noun = 0;
        this.phone = 0;
        this.time = 0;
        this.uid = 0;
        this.url = 0;
        this.value = 0;
        this.verb = 0;
    }
}
exports.DataStreamFieldSmartFields = DataStreamFieldSmartFields;
class DataStreamField {
    constructor() {
        this.avg = 0;
        this.card = 0;
        this.column = [];
        this.hidden = false;
        this.is_array = false;
        this.sample = [];
        this.sumlen = 0;
        this.usage = 0;
    }
}
exports.DataStreamField = DataStreamField;
class DataStream {
    constructor() {
        this.avg_event_size = 0;
        this.ct = 0;
        this.curct = 0;
        this.fields = [];
        this.hidden = false;
        this.recent_events = [];
    }
}
exports.DataStream = DataStream;
class TableSchemaField {
    constructor() {
        this.froms = [];
        this.hidden = false;
        this.identities = [];
        this.is_by = false;
        this.private = false;
    }
}
exports.TableSchemaField = TableSchemaField;
class TableSchema {
    constructor() {
        this.by_fields = [];
        this.columns = [];
    }
}
exports.TableSchema = TableSchema;
;
class TableSchemaFieldInfo {
    constructor() {
        this.approx_cardinality = 0;
        this.ents_absent = 0;
        this.ents_present = 0;
        this.more_terms = false;
    }
}
TableSchemaFieldInfo.getTermCounts = (obj) => {
    const counts = [];
    if (obj) {
        for (let key in obj.terms_counts) {
            const count = new TableSchemaFieldInfoTermCount();
            count.value = key;
            count.count = obj.terms_counts[key];
            counts.push(count);
        }
    }
    return counts;
};
exports.TableSchemaFieldInfo = TableSchemaFieldInfo;
;
class TableSchemaFieldInfoTermCount {
    constructor() {
        this.count = 0;
    }
}
exports.TableSchemaFieldInfoTermCount = TableSchemaFieldInfoTermCount;
class QueryValidationResult {
    constructor() {
        this.success = true;
    }
}
exports.QueryValidationResult = QueryValidationResult;
class Query {
    constructor() {
        this.by_fields = [];
        this.disabled = false;
        this.fields = [];
    }
}
exports.Query = Query;
class QueryField {
    constructor() {
        this.froms = [];
        this.hidden = false;
        this.identities = [];
        this.is_by = false;
        this.private = false;
    }
}
exports.QueryField = QueryField;
class CollectResultInfo {
    constructor() {
        this.message_count = 0;
        this.rejected_count = 0;
        this.droperrors = false;
        this.dryrun = false;
    }
}
exports.CollectResultInfo = CollectResultInfo;
class SegmentGrouping {
    constructor() {
        this.audiences = [];
        this.characteristics = [];
        this.unidentified = [];
    }
}
exports.SegmentGrouping = SegmentGrouping;
class Segment {
    constructor() {
        this.aid = 0;
        this.datemath_calc = false;
        this.deleted = false;
        this.forward_datemath = false;
        this.invalid = false;
        this.is_public = false;
        this.save_hist = false;
        this.schedule_exit = false;
        this.tags = [];
    }
}
exports.Segment = Segment;
;
class SegmentCollectionMember {
    constructor() {
        this.order = 0;
    }
}
exports.SegmentCollectionMember = SegmentCollectionMember;
class SegmentCollection {
    constructor() {
        this.aid = 0;
        this.internal = false;
        this.collection = [];
    }
}
exports.SegmentCollection = SegmentCollection;
class Campaign {
    constructor() {
        this.aid = 0;
        this.segments = [];
    }
}
exports.Campaign = Campaign;
class CampaignVariation {
    constructor() {
        this.aid = 0;
        this.variation = 0;
    }
}
exports.CampaignVariation = CampaignVariation;
class CampaignVariationDetail {
    constructor() {
        this.appearsOn = [];
        this.colors = [];
        this.displayOptions = [];
        this.formFields = [];
    }
}
exports.CampaignVariationDetail = CampaignVariationDetail;
class CampaignVariationAppearanceRule {
    constructor() {
        this.exclude = false;
    }
}
exports.CampaignVariationAppearanceRule = CampaignVariationAppearanceRule;
class CampaignVariationColor {
}
exports.CampaignVariationColor = CampaignVariationColor;
class CampaignVariationDisplayOption {
}
exports.CampaignVariationDisplayOption = CampaignVariationDisplayOption;
class CampaignVariationFormField {
    constructor() {
        this.isEnabled = false;
        this.isRequired = false;
    }
}
exports.CampaignVariationFormField = CampaignVariationFormField;
class CampaignVariationDetailOverride {
    constructor() {
        this.formElements = [];
        this.formFields = [];
    }
}
exports.CampaignVariationDetailOverride = CampaignVariationDetailOverride;
class CampaignVariationDetailOverrideConfirmAction {
    constructor() {
        this.waitForAsyncResponse = false;
    }
}
exports.CampaignVariationDetailOverrideConfirmAction = CampaignVariationDetailOverrideConfirmAction;
class CampaignVariationDetailOverrideFields {
    constructor() {
        this.name = true;
        this.email = true;
        this.title = true;
        this.company = true;
        this.phone = true;
        this.referralEmail = true;
        this.message = true;
    }
}
exports.CampaignVariationDetailOverrideFields = CampaignVariationDetailOverrideFields;
class CampaignVariationDetailOverrideFormElement {
    constructor() {
        this.required = false;
    }
}
exports.CampaignVariationDetailOverrideFormElement = CampaignVariationDetailOverrideFormElement;
class CampaignVariationDetailOverrideFormStates {
}
exports.CampaignVariationDetailOverrideFormStates = CampaignVariationDetailOverrideFormStates;
class CampaignVariationDetailOverrideFormState {
    constructor() {
        this.delay = 0;
    }
}
exports.CampaignVariationDetailOverrideFormState = CampaignVariationDetailOverrideFormState;
class ContentClassification {
    constructor() {
        this.httpstatus = 0;
        this.httpfailures = 0;
        this.tags = [];
        this.images = [];
        this.videos = [];
        this.numpages = 0;
        this.version = 0;
    }
}
exports.ContentClassification = ContentClassification;
class ContentClassificationUrl {
    constructor() {
        this.Https = false;
        this.IsStatic = false;
    }
}
exports.ContentClassificationUrl = ContentClassificationUrl;
class ContentClassificationTag {
    constructor() {
        this.relevance = 0;
    }
}
exports.ContentClassificationTag = ContentClassificationTag;
class ContentClassificationImage {
}
exports.ContentClassificationImage = ContentClassificationImage;
class ContentClassificationVideo {
}
exports.ContentClassificationVideo = ContentClassificationVideo;
class Topic {
    constructor() {
        this.doc_count = 0;
        this.total = 0;
        this.missing = 0;
        this.present = 0;
        this.bucket_none = 0;
        this.bucket_low = 0;
        this.bucket_mid = 0;
        this.bucket_high = 0;
        this.avg = 0;
        this.tags = [];
    }
}
exports.Topic = Topic;
class TopicUrl {
    constructor() {
        this.https = false;
        this.topics = [];
        this.aspects = [];
        this.meta = [];
    }
}
exports.TopicUrl = TopicUrl;
class TopicUrlCollection {
    constructor() {
        this.total = 0;
        this.urls = [];
    }
}
exports.TopicUrlCollection = TopicUrlCollection;
class Subscription {
    constructor() {
        this.aid = 0;
        this.withbackfill = false;
        this.segment_ids = [];
    }
}
exports.Subscription = Subscription;
class SubscriptionConfig {
    constructor() {
        this.segment_ids = [];
        this.user_fields = [];
    }
}
exports.SubscriptionConfig = SubscriptionConfig;
class WebhookConfig {
    constructor() {
        this.channel = "webhook";
        this.version = "new";
        this.segment_ids = [];
        this.user_fields = [];
    }
}
WebhookConfig.isValid = (obj) => {
    if (obj) {
        if (!obj.name || obj.name.trim().length == 0) {
            return false;
        }
        if (!obj.webhook_url) {
            return false;
        }
        return true;
    }
    return false;
};
exports.WebhookConfig = WebhookConfig;
class TokenScope {
    constructor(scope, description) {
        this.scope = scope;
        this.description = description;
    }
}
TokenScope.supportedScopes = [
    new TokenScope('admin', 'can manage the account (create users, grant roles) as well as all other roles'),
    new TokenScope('data', ''),
    new TokenScope('data_write', ''),
    new TokenScope('content_manager', ''),
    new TokenScope('segment_manager', ''),
    new TokenScope('marketer', ''),
    new TokenScope('observer', ''),
    new TokenScope('data_manager', ''),
    new TokenScope('campaign_manager', ''),
    new TokenScope('general_manager', '')
];
exports.TokenScope = TokenScope;
class CreateAccessTokenConfig {
    constructor() {
        this.scopes = [];
    }
}
exports.CreateAccessTokenConfig = CreateAccessTokenConfig;
class LyticsAccessToken {
    constructor() {
        this.aid = 0;
        this.config = [];
        this.scopes = [];
    }
}
exports.LyticsAccessToken = LyticsAccessToken;
class LyticsAccessTokenReader {
}
LyticsAccessTokenReader.getApiKey = (token) => {
    if (token.config) {
        const config = token.config.find(c => c.name === 'api_key');
        if (config) {
            return config.value;
        }
    }
    return undefined;
};
exports.LyticsAccessTokenReader = LyticsAccessTokenReader;
class LyticsAccessTokenConfig {
}
exports.LyticsAccessTokenConfig = LyticsAccessTokenConfig;
class LyticsAccountSetting {
    constructor() {
        this.can_be_assigned = false;
    }
}
exports.LyticsAccountSetting = LyticsAccountSetting;
class LyticsAccountSettingField {
    constructor() {
        this.sort_order = 0;
        this.optional = false;
        this.editable = false;
        this.user_config_disabled = false;
    }
}
exports.LyticsAccountSettingField = LyticsAccountSettingField;
class DocumentTopicsResult {
    constructor() {
        this.total = 0;
        this.urls = [];
    }
}
exports.DocumentTopicsResult = DocumentTopicsResult;
class DocumentTopics {
    constructor() {
        this.https = false;
        this.topics = [];
        this.aspects = [];
        this.meta = [];
    }
}
exports.DocumentTopics = DocumentTopics;
class DataUploadConfig {
    constructor(stream) {
        this.stream = stream;
        this.dryrun = false;
    }
}
exports.DataUploadConfig = DataUploadConfig;
class DataUploadResponse {
    constructor() {
        this.message_count = 0;
        this.rejected_count = 0;
    }
}
exports.DataUploadResponse = DataUploadResponse;
class FragmentKey {
}
exports.FragmentKey = FragmentKey;
class FragmentMetadata {
    constructor() {
        this.streams = [];
        this.conflict = false;
    }
}
exports.FragmentMetadata = FragmentMetadata;
class FragmentHashManager {
    static hashValue(value) {
        value = JSON.stringify(value);
        const hash = FragmentHashManager._crypto.createHash('md5');
        return hash.update(value).digest('hex');
    }
    static getHashForKey(key) {
        let value = key;
        if (Array.isArray(key)) {
            const compare = function (a, b) {
                if (a.key < b.key)
                    return -1;
                if (a.key > b.key)
                    return 1;
                return 0;
            };
            value = key.slice().sort(compare);
        }
        return FragmentHashManager.hashValue(value);
    }
}
FragmentHashManager._crypto = require('crypto');
exports.FragmentHashManager = FragmentHashManager;
class Fragment {
    constructor() {
        this.key = [];
        this.neighbors = [];
    }
}
exports.Fragment = Fragment;
class FragmentCollection {
    constructor() {
        this.keys = [];
        this.fragments = [];
    }
}
exports.FragmentCollection = FragmentCollection;
class DOT {
    // private static _crypto = require('crypto');
    // private static hashValue(value: any): string {
    //     value = JSON.stringify(value);
    //     const hash = DOT._crypto.createHash('md5');
    //     return hash.update(value).digest('hex');
    // }
    static fragmentsToDot(fragments) {
        if (util_1.isNullOrUndefined(fragments)) {
            return undefined;
        }
        //
        //
        let position = 0;
        const fragmentPositions = new Map();
        const keyForFragments = new Map();
        for (let i = 0; i < fragments.length; i++) {
            const fragment = fragments[i];
            const position = i;
            fragmentPositions.set(fragment, position);
            //
            const keys = [];
            fragment.key.forEach(key => {
                keys.push(FragmentHashManager.getHashForKey(key));
            });
            const hashedKey = FragmentHashManager.getHashForKey(fragment.key);
            if (keys.indexOf(hashedKey) === -1) {
                keys.push(hashedKey);
            }
            keys.forEach(key => {
                let fragments = keyForFragments.get(key);
                if (!fragments) {
                    fragments = [];
                }
                if (fragments.indexOf(fragment) === -1) {
                    fragments.push(fragment);
                }
                keyForFragments.set(key, fragments);
            });
        }
        ;
        //
        //
        const dotNodes = [];
        const dotEdges = [];
        fragmentPositions.forEach((position, fragment) => {
            dotNodes.push(`${position}`);
            if (fragment.neighbors) {
                for (let n = 0; n < fragment.neighbors.length; n++) {
                    const neighbor = fragment.neighbors[n];
                    const hashedNeighborKey = FragmentHashManager.getHashForKey(neighbor);
                    const neighborFragments = keyForFragments.get(hashedNeighborKey);
                    if (neighborFragments) {
                        for (let f = 0; f < neighborFragments.length; f++) {
                            const fragment = neighborFragments[f];
                            const neighborPosition = fragmentPositions.get(fragment);
                            if (position != neighborPosition) {
                                const opt1 = `${position} -- ${neighborPosition}`;
                                const opt2 = `${neighborPosition} -- ${position}`;
                                if (dotEdges.indexOf(opt1) == -1 && dotEdges.indexOf(opt2) == -1) {
                                    dotEdges.push(opt1);
                                }
                            }
                        }
                    }
                }
            }
        });
        const str = `dinetwork {${dotNodes.join(';')};${dotEdges.join(';')}}`;
        return str;
    }
}
exports.DOT = DOT;
class SegmentMLModel {
    constructor() {
        this.features = [];
    }
    static getModelGeneration(name) {
        const parts = name.split('::');
        if (parts.length == 3) {
            return parseInt(parts[2]);
        }
        return 0;
    }
    static getModelNameWithoutGeneration(name) {
        const parts = name.split('::');
        if (parts.length == 3) {
            name = parts.splice(0, 2).join('::');
        }
        return name;
    }
}
exports.SegmentMLModel = SegmentMLModel;
class SegmentMLSummary {
    constructor() {
        this.mse = 0;
        this.rsq = 0;
        this.auc = 0;
        this.threshold = 0;
    }
}
exports.SegmentMLSummary = SegmentMLSummary;
class SegmentMLSummaryConflicts {
    constructor() {
        this.FalsePositive = 0;
        this.TruePositive = 0;
        this.FalseNegative = 0;
        this.TrueNegative = 0;
    }
}
exports.SegmentMLSummaryConflicts = SegmentMLSummaryConflicts;
class SegmentMLModelFeature {
    constructor() {
        this.importance = 0;
        this.correlation = 0;
    }
}
exports.SegmentMLModelFeature = SegmentMLModelFeature;
class SegmentMLModelConfig {
}
exports.SegmentMLModelConfig = SegmentMLModelConfig;
class SegmentMLModelSegment {
    constructor() {
        this.aid = 0;
        this.invalid = false;
        this.deleted = false;
        this.datemath_calc = false;
        this.forward_datemath = false;
        this.save_hist = false;
        this.schedule_exit = false;
        this.tags = [];
    }
}
exports.SegmentMLModelSegment = SegmentMLModelSegment;
class CreateSegmentMLModelConfig {
    constructor() {
        this.use_scores = false;
        this.use_content = false;
        this.aspect_collections = [];
        this.additional_fields = [];
        this.model_only = true;
        this.eval_only = false;
        this.tune_model = false;
        this.write_to_gcs = false;
        this.tags = [];
        this.re_run = false;
        this.save_segments = false;
        this.as_is = false;
    }
}
exports.CreateSegmentMLModelConfig = CreateSegmentMLModelConfig;
//# sourceMappingURL=types.js.map