"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const types_1 = require("../types");
const jsonContent = '{"keys":[{"key":"hashedurl","value":"8197029859537599926"}],"entity":{"_created":"2018-08-23T20:35:45.699540717Z","_modified":"2018-10-17T19:43:58.73961012Z","aspects":["other"],"created":"2018-08-23T20:35:43Z","description":"Freeze: Home","enriched":{"diffbot":1535059732,"meta":1535056545},"fetched":"2018-08-23T20:35:45Z","hashedurl":["8197029859537599926"],"httpfailures":"10","httpstatus":"404","httpstatuses":["200","404"],"language":"en","meta":["viewport=width=device-width, initial-scale=1.0"],"source":"diffbot","stream":"default","type":"web","updated":"2018-10-17T19:43:58Z","url":"lytics-training-arke.appspot.com","version":"4","wordct":"38"},"fragments":[{"key":[{"key":"hashedurl","value":"8197029859537599926"}],"neighbors":null,"fragment":{"_created":"2018-08-23T20:35:45.699540717Z","_modified":"2018-10-17T19:43:58.73961012Z","aspects":["other"],"created":"2018-08-23T20:35:43Z","description":"Freeze: Home","enriched":{"diffbot":1535059732,"meta":1535056545},"fetched":"2018-08-23T20:35:45Z","hashedurl":["8197029859537599926"],"httpfailures":"10","httpstatus":"404","httpstatuses":["200","404"],"language":"en","meta":["viewport=width=device-width, initial-scale=1.0"],"source":"diffbot","stream":"default","type":"web","updated":"2018-10-17T19:43:58Z","url":"lytics-training-arke.appspot.com","version":"4","wordct":"38"},"meta":{"conflict":false}}]}';
const jsonUser = '{"keys":[{"key":"_","value":"4505997089054727829"},{"key":"_","value":"5297734830601623266"},{"key":"_","value":"15738041453579459483"},{"key":"_","value":"12789482243128844358"},{"key":"_","value":"8690050259165795310"},{"key":"_","value":"2660685694092932277"},{"key":"_","value":"2039967767518286255"},{"key":"_","value":"15874530710565020348"},{"key":"_uids","value":"111835.90055549104"},{"key":"emails","value":"adam.conn@gmail.com"},{"key":"marketing_verification_tokens","value":"058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e44dcb90f857ffe84e78a46a9beef3f33a26"},{"key":"_uids","value":"81332.45585060715"},{"key":"pd_prospect_id","value":"62156269"},{"key":"marketing_verification_tokens","value":"058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e345cd9dfb54fbe64e7caf6a93e8f2f53d25"},{"key":"_uids","value":"71630.1347729326"},{"key":"salesforce_lead_id","value":"00Q1N00000fu9m6UAA"}],"entity":{"_created":"2018-08-06T17:55:06.950934932Z","_modified":"2018-10-15T02:40:18.90170888Z","_uid":"111835.90055549104","_uids":["111835.90055549104","71630.1347729326","81332.45585060715"],"channels":["web"],"company":["My Job"],"company_address":"1000 SW Broadway","company_city":"Portland","company_country":"USA","company_employee_ct":"112","company_founded":"2012-01-01T00:00:00Z","company_industries":["Software, Internet & Computer Services"],"company_ly_domain":"getlytics.com","company_ly_name":"LYTICS","company_state":"US-OR","company_total_revenue":4420000,"company_url":"https://www.getlytics.com/","country":"US","devices":{"desktop":"53"},"domains":["new.lytics.com","www.lytics.com"],"email":"adam.conn@gmail.com","emaildomains":["gmail.com"],"emails":["adam.conn@gmail.com"],"event_first_seen":{"gtm.js":"2018-08-06T17:55:06.997Z","pv":"2018-08-06T17:55:06.964Z"},"event_last_seen":{"gtm.js":"2018-08-06T19:24:28.406Z","pv":"2018-08-06T19:24:28.411Z"},"first_name":"Adam","firstvisit_ts":"2018-08-06T17:55:06.95Z","hashedurls":{"-6084180830972443487":"36","6376036048957798543":"17"},"hourly":{"17":"12","18":"18","19":"23"},"hourofweek":{"41":"12","42":"18","43":"23"},"last_active_ts":"2018-08-06T19:24:28.411Z","last_name":"Conn","lastvisit_ts":"2018-08-06T19:24:28.411Z","ly_conversions":{"gdpr-consent":"4"},"ly_impressions":{"gdpr-consent":"5"},"marketing_verification_tokens":["058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e345cd9dfb54fbe64e7caf6a93e8f2f53d25","058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e44dcb90f857ffe84e78a46a9beef3f33a26"],"needs_message":{"default":0,"lytics_company_enrich":0,"marketing_show_your_profile":0,"pardot_prospects":0,"salesforce_leads":0},"next_event":{"default":"2018-08-10T21:00:00Z","lytics_company_enrich":"1754-08-30T22:43:41.128654848Z","marketing_show_your_profile":"1754-08-30T22:43:41.128654848Z","pardot_prospects":"1754-08-30T22:43:41.128654848Z","salesforce_leads":"1754-08-30T22:43:41.128654848Z"},"pageviewct":"12","pd_campaign_id":"8684","pd_comments":"Prospect unsubscribed from email communications.","pd_is_do_not_email":"1","pd_prospect_id":"62156269","pd_recent_interaction":"Never active.","pd_score":"0","pf_widget_events":["confirm","hover","show"],"pf_widget_ids":["gdpr-consent"],"pf_widget_layouts":["bar"],"pf_widget_types":["message"],"pf_widget_variants":["1"],"salesforce_email":"adam.conn@gmail.com","salesforce_last_user_imported":"2018-09-07T20:20:07Z","salesforce_lead_created_date":"2018-08-06T17:59:53Z","salesforce_lead_id":"00Q1N00000fu9m6UAA","salesforce_lead_last_activity_date":"2018-06-12T00:00:00Z","salesforce_lead_last_modified_date":"2018-09-07T20:20:07Z","salesforce_lead_name":"Adam Conn","salesforce_lead_source":"Advertising","salesforce_lead_source_original":"marketing-site-newsletter","salesforce_lead_status":"Not Active","score_frequency":"8","score_intensity":"100","score_momentum":"2","score_propensity":"0","score_quantity":"99","score_recency":"81","state":"all","streamscore_frequency":{"default":7},"streamscore_intensity":{"default":100},"streamscore_momentum":{"default":3},"streamscore_propensity":{"default":0},"streamscore_quantity":{"default":100},"streamscore_recency":{"default":81},"timezone":"-7","utm_medium_last":"CPC","utm_mediums":["CPC"],"utm_source_last":"AdWords","utm_sources":["AdWords"],"utm_term_last":"lytics","utm_terms":["lytics"],"visit_country":"US","visitct":"1","web_contact_us_type":"Your role?","web_lead_source":"marketing-site-request-demo"},"fragments":[{"key":[{"key":"emails","value":"adam.conn@gmail.com"}],"neighbors":[{"key":"_","value":"4505997089054727829"},{"key":"_","value":"5297734830601623266"},{"key":"_","value":"15738041453579459483"},{"key":"_","value":"12789482243128844358"},{"key":"_","value":"8690050259165795310"},{"key":"_","value":"2660685694092932277"},{"key":"_","value":"2039967767518286255"},{"key":"_","value":"15874530710565020348"}],"fragment":null,"meta":{"conflict":false}},{"key":[{"key":"_uids","value":"111835.90055549104"},{"key":"emails","value":"adam.conn@gmail.com"}],"neighbors":[{"key":"_uids","value":"111835.90055549104"},{"key":"emails","value":"adam.conn@gmail.com"}],"fragment":{"_created":"2018-08-06T19:16:07.431704958Z","_modified":"2018-08-06T19:24:24.97912876Z","_uid":"111835.90055549104","_uids":["111835.90055549104"],"channels":["web"],"country":"all","devices":{"desktop":"2"},"domains":["new.lytics.com","www.lytics.com"],"email":"adam.conn@gmail.com","emails":["adam.conn@gmail.com"],"first_name":"Adam","firstvisit_ts":"2018-08-06T19:16:07.431Z","hashedurls":{"-6084180830972443487":"1","6376036048957798543":"1"},"hourly":{"19":"2"},"hourofweek":{"43":"2"},"last_active_ts":"2018-08-06T19:24:24.979Z","last_name":"Conn","lastvisit_ts":"2018-08-06T19:24:24.979Z","state":"all","visit_country":"US","web_contact_us_type":"Your role?","web_lead_source":"marketing-site-request-demo"},"meta":{"streams":["default"],"conflict":false}},{"key":[{"key":"marketing_verification_tokens","value":"058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e44dcb90f857ffe84e78a46a9beef3f33a26"},{"key":"emails","value":"adam.conn@gmail.com"}],"neighbors":[{"key":"marketing_verification_tokens","value":"058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e44dcb90f857ffe84e78a46a9beef3f33a26"},{"key":"emails","value":"adam.conn@gmail.com"}],"fragment":{"_created":"2018-09-28T12:54:38.031729463Z","_modified":"2018-09-28T13:10:41.496946707Z","email":"adam.conn@gmail.com","emails":["adam.conn@gmail.com"],"first_name":"Adam","last_name":"Conn","marketing_verification_tokens":["058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e44dcb90f857ffe84e78a46a9beef3f33a26"]},"meta":{"streams":["marketing_show_your_profile"],"conflict":false}},{"key":[{"key":"emails","value":"adam.conn@gmail.com"},{"key":"_uids","value":"81332.45585060715"}],"neighbors":[{"key":"emails","value":"adam.conn@gmail.com"},{"key":"_uids","value":"81332.45585060715"}],"fragment":{"_created":"2018-08-06T17:59:50.034911595Z","_modified":"2018-08-06T17:59:50.034911595Z","_uid":"81332.45585060715","_uids":["81332.45585060715"],"channels":["web"],"devices":{"desktop":"1"},"domains":["www.lytics.com"],"email":"adam.conn@gmail.com","emails":["adam.conn@gmail.com"],"first_name":"Adam","firstvisit_ts":"2018-08-06T17:59:50.034Z","hashedurls":{"-6084180830972443487":"1"},"hourly":{"17":"1"},"hourofweek":{"41":"1"},"last_active_ts":"2018-08-06T17:59:50.034Z","last_name":"Conn","lastvisit_ts":"2018-08-06T17:59:50.034Z","visit_country":"US","web_lead_source":"marketing-site-newsletter"},"meta":{"streams":["default"],"conflict":false}},{"key":[{"key":"emails","value":"adam.conn@gmail.com"},{"key":"pd_prospect_id","value":"62156269"}],"neighbors":[{"key":"emails","value":"adam.conn@gmail.com"},{"key":"pd_prospect_id","value":"62156269"}],"fragment":{"_created":"2018-08-15T13:41:45Z","_modified":"2018-09-27T11:04:22Z","emails":["adam.conn@gmail.com"],"pd_campaign_id":"8684","pd_comments":"Prospect unsubscribed from email communications.","pd_is_do_not_email":"1","pd_prospect_id":"62156269","pd_recent_interaction":"Never active.","pd_score":"0"},"meta":{"streams":["pardot_prospects"],"conflict":false}},{"key":[{"key":"pd_prospect_id","value":"61320467"},{"key":"emails","value":"adam.conn@gmail.com"}],"neighbors":[{"key":"pd_prospect_id","value":"61320467"},{"key":"emails","value":"adam.conn@gmail.com"}],"fragment":{"_created":"2018-08-06T11:03:51Z","_modified":"2018-09-05T00:08:11Z","emails":["adam.conn@gmail.com"],"pd_campaign_id":"9534","pd_comments":"Prospect unsubscribed from email communications.","pd_company":"My Job","pd_country":"US","pd_crm_last_sync":"2018-08-24 15:02:54","pd_crm_lead_fid":"00Q1N00000fu9m6UAA","pd_crm_url":"https://na78.salesforce.com/00Q1N00000fu9m6UAA","pd_first_name":"Adam","pd_is_do_not_email":"1","pd_is_reviewed":"1","pd_last_name":"Conn","pd_prospect_id":"61320467","pd_recent_interaction":"Inactive since: Aug 6, 2018","pd_score":"111","pd_source":"Advertising","pd_website":"http://gmail.com"},"meta":{"streams":["pardot_prospects"],"conflict":true,"conflicts_with":"pd_prospect_id:62156269"}},{"key":[{"key":"emails","value":"adam.conn@gmail.com"},{"key":"marketing_verification_tokens","value":"058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e345cd9dfb54fbe64e7caf6a93e8f2f53d25"}],"neighbors":[{"key":"emails","value":"adam.conn@gmail.com"},{"key":"marketing_verification_tokens","value":"058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e345cd9dfb54fbe64e7caf6a93e8f2f53d25"}],"fragment":{"_created":"2018-09-28T13:15:30.41454701Z","_modified":"2018-09-28T13:15:30.41454701Z","email":"adam.conn@gmail.com","emails":["adam.conn@gmail.com"],"first_name":"Adam","last_name":"Conn","marketing_verification_tokens":["058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e345cd9dfb54fbe64e7caf6a93e8f2f53d25"]},"meta":{"streams":["marketing_show_your_profile"],"conflict":false}},{"key":[{"key":"emails","value":"adam.conn@gmail.com"},{"key":"_uids","value":"71630.1347729326"}],"neighbors":[{"key":"emails","value":"adam.conn@gmail.com"},{"key":"_uids","value":"71630.1347729326"}],"fragment":{"_created":"2018-08-06T18:53:24.040219172Z","_modified":"2018-08-06T18:53:24.040219172Z","_uid":"71630.1347729326","_uids":["71630.1347729326"],"channels":["web"],"company":["My Job"],"country":"all","devices":{"desktop":"1"},"domains":["www.lytics.com"],"email":"adam.conn@gmail.com","emails":["adam.conn@gmail.com"],"first_name":"Adam","firstvisit_ts":"2018-08-06T18:53:24.04Z","hashedurls":{"-6084180830972443487":"1"},"hourly":{"18":"1"},"hourofweek":{"42":"1"},"last_active_ts":"2018-08-06T18:53:24.04Z","last_name":"Conn","lastvisit_ts":"2018-08-06T18:53:24.04Z","state":"all","visit_country":"US","web_contact_us_type":"other","web_lead_source":"marketing-site-request-demo"},"meta":{"streams":["default"],"conflict":false}},{"key":[{"key":"salesforce_lead_id","value":"00Q1N00000fu9m6UAA"},{"key":"emails","value":"adam.conn@gmail.com"}],"neighbors":[{"key":"salesforce_lead_id","value":"00Q1N00000fu9m6UAA"},{"key":"emails","value":"adam.conn@gmail.com"}],"fragment":{"_created":"2018-08-06T19:34:04Z","_modified":"2018-09-07T20:20:07Z","company":["My Job"],"country":"US","email":"adam.conn@gmail.com","emaildomains":["gmail.com"],"emails":["adam.conn@gmail.com"],"first_name":"Adam","last_name":"Conn","salesforce_email":"adam.conn@gmail.com","salesforce_last_user_imported":"2018-09-07T20:20:07Z","salesforce_lead_created_date":"2018-08-06T17:59:53Z","salesforce_lead_id":"00Q1N00000fu9m6UAA","salesforce_lead_last_activity_date":"2018-06-12T00:00:00Z","salesforce_lead_last_modified_date":"2018-09-07T20:20:07Z","salesforce_lead_name":"Adam Conn","salesforce_lead_source":"Advertising","salesforce_lead_source_original":"marketing-site-newsletter","salesforce_lead_status":"Not Active"},"meta":{"streams":["salesforce_leads"],"conflict":false}},{"key":[{"key":"_uids","value":"111835.90055549104"}],"neighbors":[{"key":"_","value":"4505997089054727829"}],"fragment":{"_created":"2018-08-06T18:54:12.258574881Z","_modified":"2018-08-06T19:24:28.411973314Z","_uid":"111835.90055549104","_uids":["111835.90055549104"],"channels":["web"],"company_address":"1000 SW Broadway","company_city":"Portland","company_country":"USA","company_employee_ct":"112","company_founded":"2012-01-01T00:00:00Z","company_industries":["Software, Internet & Computer Services"],"company_ly_domain":"getlytics.com","company_ly_name":"LYTICS","company_state":"US-OR","company_total_revenue":4420000,"company_url":"https://www.getlytics.com/","devices":{"desktop":"29"},"domains":["new.lytics.com","www.lytics.com"],"event_first_seen":{"gtm.js":"2018-08-06T18:54:12.258Z","pv":"2018-08-06T18:54:12.259Z"},"event_last_seen":{"gtm.js":"2018-08-06T19:24:28.406Z","pv":"2018-08-06T19:24:28.411Z"},"firstvisit_ts":"2018-08-06T18:54:12.258Z","hashedurls":{"-6084180830972443487":"13","6376036048957798543":"16"},"hourly":{"18":"8","19":"21"},"hourofweek":{"42":"8","43":"21"},"last_active_ts":"2018-08-06T19:24:28.411Z","lastvisit_ts":"2018-08-06T19:24:28.411Z","ly_conversions":{"gdpr-consent":"2"},"ly_impressions":{"gdpr-consent":"3"},"pageviewct":"7","pf_widget_events":["confirm","hover","show"],"pf_widget_ids":["gdpr-consent"],"pf_widget_layouts":["bar"],"pf_widget_types":["message"],"pf_widget_variants":["1"],"timezone":"-7","utm_medium_last":"CPC","utm_mediums":["CPC"],"utm_source_last":"AdWords","utm_sources":["AdWords"],"utm_term_last":"lytics","utm_terms":["lytics"],"visit_country":"US"},"meta":{"streams":["default","lytics_company_enrich"],"conflict":false}},{"key":[{"key":"marketing_verification_tokens","value":"058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e44dcb90f857ffe84e78a46a9beef3f33a26"}],"neighbors":[{"key":"_","value":"5297734830601623266"}],"fragment":null,"meta":{"conflict":false}},{"key":[{"key":"_uids","value":"81332.45585060715"}],"neighbors":[{"key":"_","value":"15738041453579459483"}],"fragment":{"_created":"2018-08-06T17:55:06.950934932Z","_modified":"2018-08-06T17:59:53.475797594Z","_uid":"81332.45585060715","_uids":["81332.45585060715"],"channels":["web"],"company_address":"1000 SW Broadway","company_city":"Portland","company_country":"USA","company_employee_ct":"112","company_founded":"2012-01-01T00:00:00Z","company_industries":["Software, Internet & Computer Services"],"company_ly_domain":"getlytics.com","company_ly_name":"LYTICS","company_state":"US-OR","company_total_revenue":4420000,"company_url":"https://www.getlytics.com/","devices":{"desktop":"11"},"domains":["www.lytics.com"],"event_first_seen":{"gtm.js":"2018-08-06T17:55:06.997Z","pv":"2018-08-06T17:55:06.964Z"},"event_last_seen":{"gtm.js":"2018-08-06T17:59:53.474Z","pv":"2018-08-06T17:59:53.475Z"},"firstvisit_ts":"2018-08-06T17:55:06.95Z","hashedurls":{"-6084180830972443487":"11"},"hourly":{"17":"11"},"hourofweek":{"41":"11"},"last_active_ts":"2018-08-06T17:59:53.475Z","lastvisit_ts":"2018-08-06T17:59:53.475Z","ly_conversions":{"gdpr-consent":"1"},"ly_impressions":{"gdpr-consent":"1"},"pageviewct":"2","pf_widget_events":["confirm","hover","show"],"pf_widget_ids":["gdpr-consent"],"pf_widget_layouts":["bar"],"pf_widget_types":["message"],"pf_widget_variants":["1"],"timezone":"-7","utm_medium_last":"CPC","utm_mediums":["CPC"],"utm_source_last":"AdWords","utm_sources":["AdWords"],"utm_term_last":"lytics","utm_terms":["lytics"],"visit_country":"US"},"meta":{"streams":["lytics_company_enrich","default"],"conflict":false}},{"key":[{"key":"pd_prospect_id","value":"62156269"}],"neighbors":[{"key":"_","value":"12789482243128844358"}],"fragment":null,"meta":{"conflict":false}},{"key":[{"key":"marketing_verification_tokens","value":"058ad59d6f72777e3e69e300f3ea10d5b04089a8f1e3dc69688a5a7890952f31cf0dc691c5d18a1984dc7977e345cd9dfb54fbe64e7caf6a93e8f2f53d25"}],"neighbors":[{"key":"_","value":"2660685694092932277"}],"fragment":null,"meta":{"conflict":false}},{"key":[{"key":"_uids","value":"71630.1347729326"}],"neighbors":[{"key":"_","value":"2039967767518286255"}],"fragment":{"_created":"2018-08-06T18:52:24.920872075Z","_modified":"2018-08-06T18:53:28.299783113Z","_uid":"71630.1347729326","_uids":["71630.1347729326"],"channels":["web"],"company_address":"1000 SW Broadway","company_city":"Portland","company_country":"USA","company_employee_ct":"112","company_founded":"2012-01-01T00:00:00Z","company_industries":["Software, Internet & Computer Services"],"company_ly_domain":"getlytics.com","company_ly_name":"LYTICS","company_state":"US-OR","company_total_revenue":4420000,"company_url":"https://www.getlytics.com/","devices":{"desktop":"9"},"domains":["www.lytics.com"],"event_first_seen":{"gtm.js":"2018-08-06T18:53:28.299Z","pv":"2018-08-06T18:52:24.943Z"},"event_last_seen":{"gtm.js":"2018-08-06T18:53:28.299Z","pv":"2018-08-06T18:53:28.299Z"},"firstvisit_ts":"2018-08-06T18:52:24.92Z","hashedurls":{"-6084180830972443487":"9"},"hourly":{"18":"9"},"hourofweek":{"42":"9"},"last_active_ts":"2018-08-06T18:53:28.299Z","lastvisit_ts":"2018-08-06T18:53:28.299Z","ly_conversions":{"gdpr-consent":"1"},"ly_impressions":{"gdpr-consent":"1"},"pageviewct":"3","pf_widget_events":["confirm","hover","show"],"pf_widget_ids":["gdpr-consent"],"pf_widget_layouts":["bar"],"pf_widget_types":["message"],"pf_widget_variants":["1"],"timezone":"-7","utm_medium_last":"CPC","utm_mediums":["CPC"],"utm_source_last":"AdWords","utm_sources":["AdWords"],"utm_term_last":"lytics","utm_terms":["lytics"],"visit_country":"US","visitct":"1"},"meta":{"streams":["default","lytics_company_enrich"],"conflict":false}},{"key":[{"key":"salesforce_lead_id","value":"00Q1N00000fu9m6UAA"}],"neighbors":[{"key":"_","value":"15874530710565020348"}],"fragment":null,"meta":{"conflict":false}}]}';
describe('DOT', function () {
    it('should return a string when user fragments are provided', function () {
        return __awaiter(this, void 0, void 0, function* () {
            const collection = JSON.parse(jsonUser);
            const str = types_1.DOT.fragmentsToDot(collection.fragments);
            chai_1.assert.isDefined(str);
        });
    });
    it('should return a string when content fragments are provided', function () {
        return __awaiter(this, void 0, void 0, function* () {
            const collection = JSON.parse(jsonContent);
            const str = types_1.DOT.fragmentsToDot(collection.fragments);
            chai_1.assert.isDefined(str);
        });
    });
});
//# sourceMappingURL=DOT.spec.js.map